#import "GPGMEController.h"

@implementation GPGMEController

- (IBAction)signAndEncrypt:(id)sender
{
    GPGContext *context = nil;
    GPGRecipients *gpgRecipient = nil;
    GPGKey *gpgSigner = nil;
    GPGData *gpgData = nil;
    GPGData *gpgOutput = nil;

    NS_DURING
        //initializers
        context = [[GPGContext alloc] init];
        gpgData = [[GPGData alloc] initWithString: [input stringValue]];
        gpgRecipient = [[GPGRecipients alloc] init];

        //get the recipients

        [gpgRecipient addName: [recipient stringValue]];

        //get the signers

        gpgSigner =
            [[context keyEnumeratorForSearchPattern: [signer stringValue]
                                     secretKeysOnly: YES] nextObject];

        [context stopKeyEnumeration];

        //set up the context

        [context addSignerKey: gpgSigner];
        [context setPassphraseDelegate: self];
        [context setUsesArmor: YES];

        //do the GPG magic

        gpgOutput = [context encryptedSignedData: gpgData
                                   forRecipients: gpgRecipient
                           allRecipientsAreValid: nil
            ];

        //display output

        [output setStringValue: [gpgOutput string]];
        
    NS_HANDLER
        NSRunAlertPanel(@"Oops, you broke it.", @"%@",
                        nil, nil, nil, localException);
    NS_ENDHANDLER
    
    [context release];
    [gpgData release];
    [gpgRecipient release];
}

- (NSString *) context: (GPGContext *)context
      passphraseForKey: (GPGKey *)key
                 again: (BOOL)again
{
    return [passphrase stringValue];
}

@end
